;================================================================================
    include \masm32\include\masm32rt.inc
    include fpu.inc
    includelib fpu.lib
;================================================================================
; Approximate limits per Simply Fpu:
; REAL4: 3.4e38, 1.17e-38
; REAL8: 1.79e308, 2.22e-308
; REAL10: 1.19e4932, 3.36e-4932
; Approximate limits per MASM 6.0 Programmers Guide:
; REAL4: 3.4e38, 1.18e-38
; REAL8: 1.79e308, 2.23e-308
; REAL10: 1.18e4932, 3.37e-4932
;================================================================================
    .data

        ;-----------------------------------------------------
        ; Values restricted to what MASM 6.14 would assemble.
        ;-----------------------------------------------------

        r4_0  REAL4 3.40e38
        r4_1  REAL4 1.18e-38

        r8_0  REAL8 1.79e308
        r8_1  REAL8 2.23e-308

        r10_0 REAL10 1.18e4932
        r10_1 REAL10 3.36e-4932
        r10_2 REAL10 3.37e-4932
        r10_3 REAL10 3.36e-4917   ; smallest value with no error

        buff  db    40 dup(0)

    .code
;================================================================================
start:
;================================================================================

    invoke FpuFLtoA, ADDR r4_0, 6, ADDR buff, SRC1_REAL4 or SRC2_DIMM or STR_SCI
    print ADDR buff,13,10

    invoke FpuFLtoA, ADDR r4_1, 6, ADDR buff, SRC1_REAL4 or SRC2_DIMM or STR_SCI
    print ADDR buff,13,10,13,10

    invoke FpuFLtoA, ADDR r8_0, 15, ADDR buff, SRC1_REAL8 or SRC2_DIMM or STR_SCI
    print ADDR buff,13,10

    invoke FpuFLtoA, ADDR r8_1, 15, ADDR buff, SRC1_REAL8 or SRC2_DIMM or STR_SCI
    print ADDR buff,13,10,13,10

    invoke FpuFLtoA, ADDR r10_0, 19, ADDR buff, SRC1_REAL or SRC2_DIMM or STR_SCI
    print ADDR buff,13,10

    invoke FpuFLtoA, ADDR r10_1, 19, ADDR buff, SRC1_REAL or SRC2_DIMM or STR_SCI
    print ADDR buff,13,10

    invoke FpuFLtoA, ADDR r10_2, 19, ADDR buff, SRC1_REAL or SRC2_DIMM or STR_SCI
    print ADDR buff,13,10

    invoke FpuFLtoA, ADDR r10_3, 19, ADDR buff, SRC1_REAL or SRC2_DIMM or STR_SCI
    print ADDR buff,13,10,13,10

    inkey "Press any key to exit..."
    exit
;================================================================================
end start